# WEB+DB PRESS Vol.119 連載「Perl Hackers Hub」サンプルコード

技術評論社刊「WEB+DB PRESS Vol.119」の連載「Perl Hackers Hub」第64回「少しマニアックなPerlのテクニック」（佐藤健太著）のサンプルコードです。

## vars

特殊変数を使ったサンプルコードです。

### for.pl

forを使って短く書くサンプルです。

```prompt
$ perl for.pl fizzbuzz # 任意の文字列
```

fizzあるいはbuzzがあるかどうかで出力が変わります。

### slurp.pl

forを使って短く書くサンプルです。

```prompt
$ perl slurp.pl foo
```

`foo` の内容を全て読み込んでからprintします。

`plain` と `simple` の2種類の実装がありそれぞれ引数で切り替えられます。

```prompt
$ perl slurp.pl plain
```

### print_plain.pl

`print`を2回実行して`helloworld!`と出力します。

```prompt
$ perl print_plain.pl
```

### print_multiple_args.pl

`print`に2つ引数を渡して`helloworld!`と出力します。

```prompt
$ perl print_multiple_args.pl
```

### print_with_line_sep.pl

`$\`を使って`helloworld!\n`と出力します。

```prompt
$ perl print_with_line_sep.pl
```

### print_csv.pl

`$\`と`$,`を使ってCSVを出力します。

```prompt
$ perl print_csv.pl
```

### format_error_message.pl

`$"`を使ってエラーメッセージを出力します。1/2の確率で失敗します。

```prompt
$ perl format_error_message.pl
```

## syscall

以下を本文を参考に実行し `path/to/lib` を `./sycall/lib` のフルパスに変更して実行することで`sys/syscall.ph`が生成できます。

```prompt
$ cd /usr/include/x86_64-linux-gnu # 環境による
$ h2ph -d path/to/lib -a -l sys/syscall.h
```

### sendfile.pl

sendfileシステムコールの利用例です。

```prompt
$ perl sendfile.pl foo bar
```

`foo`のファイルの内容を`bar`にコピーします。

## fileapi

低レベルなファイルAPIを使う例です。

### tail1024bytes.pl

`seek`を使って末尾から1024バイト読み込みprintします。

```
$ perl tail1024bytes.pl file
```

## const

`constant`プラグマを使った例です。

### folding.pl

**注意: これだけ確認方法が特殊です。**

B::Deparseを使って定数畳み込みの結果を見ます。

```prompt
$ perl -MO=Deparse folding.pl
```
