use strict;
use warnings;

require 'sys/syscall.ph';

my ($src, $dst) = @ARGV;
if (@ARGV != 2) {
    die "Usage: $0 src dest"
}

open my $in_fh, '<', $src
    or die "failed to open $src: $!";

open my $out_fh, '>', $dst
    or die "failed to open $dst: $!";

my $size = -s $in_fh;
my $ret = syscall(SYS_sendfile(), fileno $out_fh, fileno $in_fh,  0, $size);
if ($ret < 0) {
    warn "ret: $ret";
    warn "err: $!";
    exit -1;
}

local $\ = "\n";
print "sendfile: $src to $dst $ret bytes";
