use strict;
use warnings;
use utf8;

my $file = shift @ARGV
    or die "Usage: $0 file [plain|simple]";
my $impl = shift @ARGV || 'simple';

sub slurp_plain {
    my $file = shift;
    open my $fh, '<', $file
        or die "$!: $file";

    my $all_of_texts = '';
    for my $line (<$fh>) {
        $all_of_texts .= $line;
    }
    return $all_of_texts;
}

sub slurp_simple {
    my $file = shift;
    open my $fh, '<', $file
        or die "$!: $file";

    my $all_of_texts = do {
        # 初期化せず局所化するとundefになる
        local $/;
        <$fh>;
    };

    return $all_of_texts;
}

if ($impl eq 'plain') {
    print slurp_plain($file);
} elsif ($impl eq 'simple') {
    print slurp_simple($file);
} else {
    die "Unknown impl: $impl";
}
